﻿using Navigation_Pages_MVVM.Model;
using System.Collections.Generic;

namespace Navigation_Pages_MVVM.Singletons
{
    public sealed class Arguments
    {
        private static readonly Arguments instance = new Arguments();

        private Arguments() { }

        public static string Usage
        {
            get
            {
                if (_Usage == null)
                {
                    _Usage = string.Format("{0} [Parameter1=Value] [Parameter2=\"Some Other Value\"]", DataStore.ExeFile);
                }
                return _Usage;
            }
        } static string _Usage;

        public static ArgumentList ValidArguments
        {
            get
            {
                if (_ValidArguments == null)
                {
                    _ValidArguments = new ArgumentList();
                    _ValidArguments.Add(new Argument() { Name = "FirstName", Description = "Your first name." });
                    _ValidArguments.Add(new Argument() { Name = "LastName", Description = "Your last name." });
                }
                return _ValidArguments;
            }
        } static ArgumentList _ValidArguments;

        public static List<ArgumentExample> Examples
        {
            get
            {
                if (_Examples == null)
                {
                    _Examples = new List<ArgumentExample>();
                    _Examples.Add(new ArgumentExample()
                    {
                        Description = "These parameters demonstrat populating the FirstName and LastName automatically using the command line.",
                        Example = string.Format("{0} FirstName=John LastName=Johnson", DataStore.ExeFile),
                    });
                }
                return _Examples;
            }
        } static List<ArgumentExample> _Examples;

    }
}
