﻿using Navigation_Pages_MVVM.View;
using Navigation_Pages_MVVM.Singletons;

namespace Navigation_Pages_MVVM.ViewModel
{
    class Page1ViewModel : PageViewModelBase
    {
        const string FIRSTNAME = "FirstName";
        const string LASTNAME = "LastName";

        public Page1ViewModel()
        {
            ButtonPrevious.IsEnabled = false;
            ButtonPrevious.IsVisible = false;

            Heading = "Page 1";

            if (DataStore.Information.ContainsKey(FIRSTNAME))
                DataStore.Information.TryGetValue(FIRSTNAME, out _FirstName);

            if (DataStore.Information.ContainsKey(LASTNAME))
                DataStore.Information.TryGetValue(LASTNAME, out _LastName);
        }

        public string FirstName
        {
            get { return _FirstName; }
            set
            {
                _FirstName = value;
                NotifyPropertyChanged(FIRSTNAME);
                NotifyPropertyChanged("ButtonContinue");
            }
        } string _FirstName;

        public string LastName
        {
            get { return _LastName; }
            set
            {
                _LastName = value;
                NotifyPropertyChanged(LASTNAME);
                NotifyPropertyChanged("ButtonContinue");
            }
        } string _LastName;

        public override void ButtonContinueClick()
        {
            // Save data to DataStore.Information
            if (DataStore.Information.ContainsKey(FIRSTNAME))
                DataStore.Information.Remove(FIRSTNAME);
            DataStore.Information.Add(FIRSTNAME, FirstName);

            if (DataStore.Information.ContainsKey(LASTNAME))
                DataStore.Information.Remove(LASTNAME);
            DataStore.Information.Add(LASTNAME, LastName);
            
            // Go to next page
            Page2ViewModel vm = new Page2ViewModel();
            Page2 p2 = new Page2();
            p2.DataContext = vm;
            Navigator.NavigationService.Navigate(p2);
        }

        public override bool IsValid()
        {
            return !string.IsNullOrWhiteSpace(FirstName) && !string.IsNullOrWhiteSpace(LastName);
        }
    }
}
