﻿using Navigation_Pages_MVVM.View;
using Navigation_Pages_MVVM.Singletons;
using Navigation_Pages_MVVM.Model;

namespace Navigation_Pages_MVVM.ViewModel
{
    class Page2ViewModel : PageViewModelBase
    {
        const string MOUTH = "Mouth";

        public Page2ViewModel()
        {
            Heading = "Page 2";

            string mouth = string.Empty;
            if (DataStore.Information.TryGetValue(MOUTH, out mouth))
            {
                if (mouth.Equals("Smile", System.StringComparison.CurrentCultureIgnoreCase))
                    MouthType = Mouth.Type.Smile;
                else
                    MouthType = Mouth.Type.Frown;
            }
            else
            {
                MouthType = Mouth.Type.Smile;
            }
        }
        
        public Mouth.Type MouthType { get; set; }

        public override void ButtonContinueClick()
        {
            // Save data to DataStore
            if (DataStore.Information.ContainsKey(MOUTH))
                DataStore.Information.Remove(MOUTH);
            DataStore.Information.Add(MOUTH, MouthType.ToString());


            Page3ViewModel vm = new Page3ViewModel();
            Page3 p3 = new Page3();
            p3.DataContext = vm;
            Navigator.NavigationService.Navigate(p3);
        }

        public override bool IsValid()
        {
            return true;
        }
    }
}
